Foxit PDF SDK

Public Member Functions | Static Public Attributes | List of all members
com.foxit.sdk.common.Renderer Class Reference
Inheritance diagram for com.foxit.sdk.common.Renderer:

## Public Member Functions
| Renderer (Bitmap bitmap, boolean is_rgb_order) throws com.foxit.sdk.PDFException
| Constructor, with bitmap. More...
| Renderer (PrintDeviceSettingData print_param, String dest_file_path) throws com.foxit.sdk.PDFException
| Constructor for printing, with specified print device setting data. More...
| Renderer (Renderer other)
| Constructor, with another renderer object. More...
void | clearClips () throws com.foxit.sdk.PDFException
| Clear the clipping rectangle set by function Renderer.setClipRect . More...
synchronized void | delete ()
| Clean up related C++ resources immediately. More...
void | enableForPrint (boolean is_render_for_print) throws com.foxit.sdk.PDFException
| Set the flag to decide whether to do rendering in print mode. More...
boolean | isEmpty ()
| Check whether current object is empty or not. More...
boolean | renderAnnot (Annot annot, Matrix2D matrix) throws com.foxit.sdk.PDFException
| Render a specified annotation. More...
boolean | renderFormControls (PDFPage page, Matrix2D matrix) throws com.foxit.sdk.PDFException
| Render form controls. More...
boolean | renderGraphicsObject (GraphicsObject graphics_object, PDFPage page, Matrix2D matrix) throws com.foxit.sdk.PDFException
| Render a graphics object. More...
void | setClearType (boolean is_clear_type) throws com.foxit.sdk.PDFException
| Set the flag to decide whether to use ClearType-like anti-aliasing to render text objects. More...
void | setClipPathFill (Path clip_path, Matrix2D matrix, int fill_mode) throws com.foxit.sdk.PDFException
| Set clipping path using filled region. More...
void | setClipPathStroke (Path clip_path, Matrix2D matrix, GraphState graph_state) throws com.foxit.sdk.PDFException
| Set clipping path using stroked region. More...
void | setClipRect (RectI clip_rect) throws com.foxit.sdk.PDFException
| Set the clipping rectangle which will be used in subsequent rendering progress. More...
void | setColorMode (int color_mode) throws com.foxit.sdk.PDFException
| Set color mode. More...
void | setForceDownSample (boolean is_to_force_down_sample) throws com.foxit.sdk.PDFException
| Set the flag to decide whether to use down-sampling for image stretching. More...
void | setForceHalftone (boolean is_to_force_halftone) throws com.foxit.sdk.PDFException
| Set the flag to decide whether to use halftone for image stretching. More...
void | setForegroundColor (long foreground_color) throws com.foxit.sdk.PDFException
| Set foreground color for text, path or both when color mode is com.foxit.sdk.common.Renderer.e_ColorModeForeground . More...
void | setForegroundColorMode (int foreground_color_mode) throws com.foxit.sdk.PDFException
| Set rendering foreground color mode when color mode is com.foxit.sdk.common.Renderer.e_ColorModeForeground . More...
void | setJPEGDownSample (boolean is_jepg_down_sample) throws com.foxit.sdk.PDFException
| Set the flag to decide whether to use down-sampling for jpeg image. More...
void | setJPXDownSample (boolean is_jpx_down_sample) throws com.foxit.sdk.PDFException
| Set the flag to decide whether to use down-sampling for jpx image. More...
void | setLayerContext (LayerContext layer_context) throws com.foxit.sdk.PDFException
| Set layer context to render context handle. More...
void | setMappingModeColors (long background_color, long foreground_color) throws com.foxit.sdk.PDFException
| Set background color and foreground color when color mode is com.foxit.sdk.addon.ofd.OFDRenderer.e_ColorModeMappingGray or com.foxit.sdk.addon.ofd.OFDRenderer.e_ColorModeMapping . More...
void | setOverprint (boolean is_to_enable_overprint) throws com.foxit.sdk.PDFException
| Set the flag to decide whether to enable overprint. More...
void | setPrintTextAsGraphic (boolean is_to_print_text_graphic) throws com.foxit.sdk.PDFException
| Set the flag to decide whether to print text as path or bitmap. More...
void | setPrintTextAsImage (boolean is_to_print_text_image) throws com.foxit.sdk.PDFException
| Set the flag to decide whether to print text as image. More...
void | setRenderAnnotAppearanceType (int ap_type) throws com.foxit.sdk.PDFException
| Set the annotation's appearance type for rendering. More...
void | setRenderAnnotsForThumbnail (boolean is_render_annots_for_thumbnail) throws com.foxit.sdk.PDFException
| Set rendering flag to decide whether to render annotations in thumbnail mode or not. More...
void | setRenderContentFlags (int render_content_flags) throws com.foxit.sdk.PDFException
| Set rendering flag to decide what content will be rendered. More...
void | setRenderEnhanceThinLines (boolean is_render_enhance_thin_lines) throws com.foxit.sdk.PDFException
| Set the flag to decide whether to enhance thin lines. More...
void | setRenderFormField (boolean is_render_formfield) throws com.foxit.sdk.PDFException
| Set the flag to decide whether to render form fields (except signature fields). More...
void | setRenderImageAntiAliasing (boolean is_render_image_antialiasing) throws com.foxit.sdk.PDFException
| Set the flag to decide whether to draw image anti-aliasing. More...
void | setRenderLayer (boolean is_render_one_layer)
| Set the flag to decide whether to render one layer or all available layers. More...
void | setRenderPathAntiAliasing (boolean is_render_path_antialiasing) throws com.foxit.sdk.PDFException
| Set the flag to decide whether to draw path anti-aliasing. More...
void | setRenderPathFullCovered (boolean is_render_path_full_covered) throws com.foxit.sdk.PDFException
| A special flag that can be applied to fill mode. More...
void | setRenderPathThinLine (boolean is_render_path_thin_line) throws com.foxit.sdk.PDFException
| Set the flag to decide whether to draw path as thin line. More...
void | setRenderSignature (boolean is_render_signature) throws com.foxit.sdk.PDFException
| Set the flag to decide whether to render signatures or not. More...
void | setRenderSignatureState (boolean is_render_signature_state) throws com.foxit.sdk.PDFException
| Set the flag to decide whether to draw the signature state on the signature. More...
void | setRenderTextAntiAliasing (boolean is_render_text_antialiasing) throws com.foxit.sdk.PDFException
| Set the flag to decide whether to draw text anti-aliasing. More...
void | setScreenDPIScale (float scale)
| Set the screen DPI scaling factor for rendering. More...
Progressive | startQuickRender (PDFPage page, Matrix2D matrix, PauseCallback pause) throws com.foxit.sdk.PDFException
| Start to quickly render a PDF page, mainly for thumbnail purpose. More...
Progressive | startRender (PDFPage page, Matrix2D matrix, PauseCallback pause) throws com.foxit.sdk.PDFException
| Start to render a PDF page. More...
Progressive | startRenderBitmap (Bitmap bitmap, Matrix2D matrix, RectI clip_rect, int interpolation, PauseCallback pause) throws com.foxit.sdk.PDFException
| Start to render a bitmap. More...
Progressive | startRenderBitmap (Bitmap bitmap, Matrix2D matrix, RectI clip_rect, int interpolation, int alpha, PauseCallback pause) throws com.foxit.sdk.PDFException
| Start to render a bitmap. More...
Progressive | startRenderReflowPage (ReflowPage reflow_page, Matrix2D matrix, PauseCallback pause) throws com.foxit.sdk.PDFException
| Start to render a reflow page. More...
Progressive | startRenderXFAPage (XFAPage xfa_page_view, Matrix2D matrix, boolean is_highlight, PauseCallback pause) throws com.foxit.sdk.PDFException
| Start to render an XFA page. More...
Public Member Functions inherited from com.foxit.sdk.common.Base
synchronized void | delete ()
| Clean up related C++ resources immediately. More...

## Static Public Attributes
static final int | e_ColorModeAlpha = 3
| Output alpha only, ignore color.
static final int | e_ColorModeForeground = 4
| Custom color mode. map colors to foreground.
static final int | e_ColorModeForegroundBlackPath = 0x08
| If set, only the black color of path need to be replaced.
static final int | e_ColorModeForegroundBlackText = 0x04
| If set, only the black color of text need to be replaced.
static final int | e_ColorModeForegroundPath = 0x02
| If set, the color of path need to be replaced.
static final int | e_ColorModeForegroundText = 0x01
| If set, the color of text need to be replaced.
static final int | e_ColorModeMapping = 2
| Map a color value to the color range defined by a background color and a foreground color.
static final int | e_ColorModeMappingGray = 1
| Map gray/white/black color value to background/foreground; for other colors, no change.
static final int | e_ColorModeNormal = 0
| Normal color mode.
static final int | e_RenderAnnot = 0x02
| If set, annotations will be rendered.
static final int | e_RenderExceptHighlight = 0x08
| If set, all annotations expect highlight will be rendered.
static final int | e_RenderHighlight = 0x04
| If set, only highlight annotations will be rendered.
static final int | e_RenderPage = 0x01
| If set, page content will be rendered.
static final int | e_RenderScreen = 0x10
| If set, only screen annotations will be rendered.

## Detailed Description

PDF renderer is a graphics engine and is used to render page to a bitmap or a platform device context. This class can be constructed with a bitmap, or a device object. It offers functions to set rendering options/flags, and do rendering. In this class, there are several ways to do rendering:

- To render page and annotations, first use function Renderer.setRenderContentFlags to decide whether to render page and annotation both or not, and then use functions Renderer.startRender to do the rendering. Function Renderer.startQuickRender can also be used to render page but only for thumbnail purpose.

- To render a single annotation, use function Renderer.renderAnnot .

- To render a bitmap, use function Renderer.startRenderBitmap .

- To render a reflow page, use function Renderer.startRenderReflowPage .

Widget annotation is always associated with form field and form control in Foxit PDF SDK. For how to render widget annotations, here is a recommended flow:

- After loading a PDF page, first render the page and all annotations in this page (including widget annotations).

- Then, if user uses com.foxit.sdk.pdf.interform.Filler object to fill the form, user should use function pdf.interform.Filler.render to render the focused form control instead of using function Renderer.renderAnnot .

See also
  com.foxit.sdk.pdf.interform.Filler

## Constructor & Destructor Documentation

## ◆ Renderer() [1/3]

com.foxit.sdk.common.Renderer.Renderer | ( | Bitmap | bitmap,
|  | boolean | is_rgb_order
| ) |  | throws com.foxit.sdk.PDFException

Constructor, with bitmap.

The input bitmap is treated as an independent device and all the content rendered by the renderer would appear in the bitmap.

Parameters

  [in] | bitmap | A bitmap used for rendering. User should ensure the bitmap to keep valid until the end of life cycle of current renderer object.
  [in] | is_rgb_order | true means Foxit PDF SDK needs to use RGB byte-order (Red is in the lowest order) when rendering. false means Foxit PDF SDK needs to use BGR byte-order (Blue is in the lowest order) when rendering.

## ◆ Renderer() [2/3]

com.foxit.sdk.common.Renderer.Renderer | ( | PrintDeviceSettingData | print_param,
|  | String | dest_file_path
| ) |  | throws com.foxit.sdk.PDFException

Constructor for printing, with specified print device setting data.

All the content rendered by the renderer would appear in the PDF file or PostScrip file. Generating PS files is only supported on Linux systems.

Parameters

  [in] | print_param | Setting data used to print device.
  [in] | dest_file_path | The path to generate the printed PDF file or PostScrip file. If this path is a PDF file path, please ensure Foxit PDF SDK has been initialized successfully by function common.Library.initialize with a key including "Print2PDF" module.

## ◆ Renderer() [3/3]

com.foxit.sdk.common.Renderer.Renderer | ( | Renderer | other | ) |

Constructor, with another renderer object.

Parameters

  [in] | other | Another renderer object.

## Member Function Documentation

## ◆ clearClips()

void com.foxit.sdk.common.Renderer.clearClips | ( |  | ) | throws com.foxit.sdk.PDFException

Clear the clipping rectangle set by function Renderer.setClipRect .

Returns
  None.

## ◆ delete()

synchronized void com.foxit.sdk.common.Renderer.delete | ( |  | ) |

Clean up related C++ resources immediately.

Returns
  None.

Note
  Once this function is called, current object cannot be used anymore.

## ◆ enableForPrint()

void com.foxit.sdk.common.Renderer.enableForPrint | ( | boolean | is_render_for_print | ) | throws com.foxit.sdk.PDFException

Set the flag to decide whether to do rendering in print mode.

Please ensure this rendering flag is set as expected when current renderer is to used for printing. For rendering annotations, if this flag is set to be true, Foxit PDF SDK will only render annotations which have annotation flag com.foxit.sdk.pdf.annots.Annot.e_FlagPrint .
If this function is not called for current renderer object yet, default value false will be used.

Parameters

  [in] | is_render_for_print | true means to render in print mode, while false means to render not in print mode.

Returns
  None.

## ◆ isEmpty()

boolean com.foxit.sdk.common.Renderer.isEmpty | ( |  | ) |

Check whether current object is empty or not.

When the current object is empty, that means current object is useless.

Returns
  true means current object is empty, while false means not.

## ◆ renderAnnot()

boolean com.foxit.sdk.common.Renderer.renderAnnot | ( | Annot | annot,
|  | Matrix2D | matrix
| ) |  | throws com.foxit.sdk.PDFException

Render a specified annotation.

When this function is called, rendering flag (set by function Renderer.setRenderContentFlags or by default) will be ignored.

Parameters

  [in] | annot | An annotation object to be rendered. If input annot is a pop-up annotation, this function will not render it and will return false.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function pdf.PDFPage.getDisplayMatrix .

Returns
  true means success, while false means failure.

## ◆ renderFormControls()

boolean com.foxit.sdk.common.Renderer.renderFormControls | ( | PDFPage | page,
|  | Matrix2D | matrix
| ) |  | throws com.foxit.sdk.PDFException

Render form controls.

When this function is called, rendering flag (set by function Renderer.setRenderContentFlags or by default) will be ignored.

Parameters

  [in] | page | A valid PDF page. If input page is invalid, this function do nothing and return false directly.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function pdf.PDFPage.getDisplayMatrix .

Returns
  true means success, while false means failure.

## ◆ renderGraphicsObject()

boolean com.foxit.sdk.common.Renderer.renderGraphicsObject | ( | GraphicsObject | graphics_object,
|  | PDFPage | page,
|  | Matrix2D | matrix
| ) |  | throws com.foxit.sdk.PDFException

Render a graphics object.

When this function is called, rendering flag (set by function Renderer.setRenderContentFlags or by default) will be ignored.

Parameters

  [in] | graphics_object | A valid PDF graphics object to be rendered.
  [in] | page | A valid PDF page. Parameter graphics_object belongs to this PDF page.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function pdf.PDFPage.getDisplayMatrix .

Returns
  true means success, while false means failure.

## ◆ setClearType()

void com.foxit.sdk.common.Renderer.setClearType | ( | boolean | is_clear_type | ) | throws com.foxit.sdk.PDFException

Set the flag to decide whether to use ClearType-like anti-aliasing to render text objects.

If this function is not called, default value true will be used.

Parameters

  [in] | is_clear_type | true means to use ClearType-like anti-aliasing to render text objects. false means not to use ClearType-like anti-aliasing to render text objects.

Returns
  None.

## ◆ setClipPathFill()

void com.foxit.sdk.common.Renderer.setClipPathFill | ( | Path | clip_path,
|  | Matrix2D | matrix,
|  | int | fill_mode
| ) |  | throws com.foxit.sdk.PDFException

Set clipping path using filled region.

Parameters

  [in] | clip_path | A clipping path.
  [in] | matrix | The transformation matrix used for clipping.
  [in] | fill_mode | Fill mode. It should be value or .

Returns
  None.

## ◆ setClipPathStroke()

void com.foxit.sdk.common.Renderer.setClipPathStroke | ( | Path | clip_path,
|  | Matrix2D | matrix,
|  | GraphState | graph_state
| ) |  | throws com.foxit.sdk.PDFException

Set clipping path using stroked region.

Parameters

  [in] | clip_path | A clipping path.
  [in] | matrix | The transformation matrix used for clipping.
  [in] | graph_state | A valid graph state, for pen attributes. If this is null, Foxit PDF SDK will use a graph state object with default constructor. Default value: null.

Returns
  None.

## ◆ setClipRect()

void com.foxit.sdk.common.Renderer.setClipRect | ( | RectI | clip_rect | ) | throws com.foxit.sdk.PDFException

Set the clipping rectangle which will be used in subsequent rendering progress.

Parameters

  [in] | clip_rect | A clipping rectangle. If it is null, that means not to use clipping rectangle in subsequent rendering progress.

Returns
  None.

## ◆ setColorMode()

void com.foxit.sdk.common.Renderer.setColorMode | ( | int | color_mode | ) | throws com.foxit.sdk.PDFException

Set color mode.

If this function is not called, default value com.foxit.sdk.addon.ofd.OFDRenderer.e_ColorModeNormal will be used.

Parameters

  [in] | color_mode | Color mode value. It should be one of following values: com.foxit.sdk.addon.ofd.OFDRenderer.e_ColorModeNormal means normal color mode. com.foxit.sdk.addon.ofd.OFDRenderer.e_ColorModeMappingGray means to map white/black color value to background/foreground; for other colors, no change. If this mode is used, please call function Renderer.setMappingModeColors to set "background color" and "foreground color". com.foxit.sdk.addon.ofd.OFDRenderer.e_ColorModeMapping means to map a color value to the color range defined by a background color and a foreground color. If this mode is used, please call function Renderer.setMappingModeColors to set "background color" and "foreground color".

Returns
  None.

## ◆ setForceDownSample()

void com.foxit.sdk.common.Renderer.setForceDownSample | ( | boolean | is_to_force_down_sample | ) | throws com.foxit.sdk.PDFException

Set the flag to decide whether to use down-sampling for image stretching.

If this function is not called, default value false will be used.

Parameters

  [in] | is_to_force_down_sample | true means to use down-sampling for image stretching. false means not to use down-sampling for image stretching.

Returns
  None.

## ◆ setForceHalftone()

void com.foxit.sdk.common.Renderer.setForceHalftone | ( | boolean | is_to_force_halftone | ) | throws com.foxit.sdk.PDFException

Set the flag to decide whether to use halftone for image stretching.

If this function is not called, default value false will be used.

Parameters

  [in] | is_to_force_halftone | true means to use halftone for image stretching. false means not to use halftone for image stretching.

Returns
  None.

## ◆ setForegroundColor()

void com.foxit.sdk.common.Renderer.setForegroundColor | ( | long | foreground_color | ) | throws com.foxit.sdk.PDFException

Set foreground color for text, path or both when color mode is com.foxit.sdk.common.Renderer.e_ColorModeForeground .

The foreground color for text, path, or both is determined by the foreground color mode set by the function Renderer.setForegroundColorMode .

Parameters

  [in] | foreground_color | The foreground color for text, path, or both. Format: 0xAARRGGBB.

Returns
  None.

## ◆ setForegroundColorMode()

void com.foxit.sdk.common.Renderer.setForegroundColorMode | ( | int | foreground_color_mode | ) | throws com.foxit.sdk.PDFException

Set rendering foreground color mode when color mode is com.foxit.sdk.common.Renderer.e_ColorModeForeground .

If this function is not called, default value (com.foxit.sdk.common.Renderer.e_ColorModeForegroundText | com.foxit.sdk.common.Renderer.e_ColorModeForegroundPath | com.foxit.sdk.common.Renderer.e_ColorModeForegroundBlackText | com.foxit.sdk.common.Renderer.e_ColorModeForegroundBlackPath ) will be used.

Parameters

  [in] | foreground_color_mode | Rendering foreground color mode. Please refer to values starting from com.foxit.sdk.common.Renderer.e_ColorModeForegroundText and this should be one or a combination of these values.

Returns
  None.

## ◆ setJPEGDownSample()

void com.foxit.sdk.common.Renderer.setJPEGDownSample | ( | boolean | is_jepg_down_sample | ) | throws com.foxit.sdk.PDFException

Set the flag to decide whether to use down-sampling for jpeg image.

Whether to use down-sampling for jpeg image or not will affect rendering result for a PDF page. When current function is called successfully, user should called function pdf.PDFPage.clearRenderCache for a PDF page (which has been rendered at least once) before rendering the PDF page again.
If this function is not called, default value true will be used.

Parameters

  [in] | is_jepg_down_sample | true means to use down-sampling for jpeg image. false means not to use down-sampling for jpeg image.

Returns
  None.

## ◆ setJPXDownSample()

void com.foxit.sdk.common.Renderer.setJPXDownSample | ( | boolean | is_jpx_down_sample | ) | throws com.foxit.sdk.PDFException

Set the flag to decide whether to use down-sampling for jpx image.

Whether to use down-sampling for jpx image or not will affect rendering result for a PDF page. When current function is called successfully, user should called function pdf.PDFPage.clearRenderCache for a PDF page (which has been rendered at least once) before rendering the PDF page again.
If this function is not called, default value true will be used.

Parameters

  [in] | is_jpx_down_sample | true means to use down-sampling for jpx image. false means not to use down-sampling for jpx image.

Returns
  None.

## ◆ setLayerContext()

void com.foxit.sdk.common.Renderer.setLayerContext | ( | LayerContext | layer_context | ) | throws com.foxit.sdk.PDFException

Set layer context to render context handle.

In order to render one layer when PDF page's contents is rendered on a rendering context, user should call this function to set the layer context to render context.

Parameters

  [in] | layer_context | A layer context object.

Returns
  None.

## ◆ setMappingModeColors()

void com.foxit.sdk.common.Renderer.setMappingModeColors | ( | long | background_color,
|  | long | foreground_color
| ) |  | throws com.foxit.sdk.PDFException

Set background color and foreground color when color mode is com.foxit.sdk.addon.ofd.OFDRenderer.e_ColorModeMappingGray or com.foxit.sdk.addon.ofd.OFDRenderer.e_ColorModeMapping .

Parameters

  [in] | background_color | The background color. Format: 0xAARRGGBB.
  [in] | foreground_color | The foreground color. Format: 0xAARRGGBB.

Returns
  None.

## ◆ setOverprint()

void com.foxit.sdk.common.Renderer.setOverprint | ( | boolean | is_to_enable_overprint | ) | throws com.foxit.sdk.PDFException

Set the flag to decide whether to enable overprint.

Parameters

  [in] | is_to_enable_overprint | true means to enable overprint. false means not to enable overprint. Default: false.

Returns
  None.

## ◆ setPrintTextAsGraphic()

void com.foxit.sdk.common.Renderer.setPrintTextAsGraphic | ( | boolean | is_to_print_text_graphic | ) | throws com.foxit.sdk.PDFException

Set the flag to decide whether to print text as path or bitmap.

When this flag is true, Foxit PDF SDK will render text in different way: if font size is greater than 50, print text as path; otherwise, print text as bitmap.
If this function is not called, default value false will be used.

Parameters

  [in] | is_to_print_text_graphic | true means to print text as path or bitmap. false means not to print text as path or bitmap.

Returns
  None.

## ◆ setPrintTextAsImage()

void com.foxit.sdk.common.Renderer.setPrintTextAsImage | ( | boolean | is_to_print_text_image | ) | throws com.foxit.sdk.PDFException

Set the flag to decide whether to print text as image.

If this function is not called, default value false will be used.

Parameters

  [in] | is_to_print_text_image | true means to print text as image. false means not to print text as image.

Returns
  None.

## ◆ setRenderAnnotAppearanceType()

void com.foxit.sdk.common.Renderer.setRenderAnnotAppearanceType | ( | int | ap_type | ) | throws com.foxit.sdk.PDFException

Set the annotation's appearance type for rendering.

Parameters

  [in] | ap_type | Type of annotation's appearance. Please refer to values starting from com.foxit.sdk.pdf.annots.Annot.e_AppearanceTypeNormal and this should be one of these values.

Returns
  None.

## ◆ setRenderAnnotsForThumbnail()

void com.foxit.sdk.common.Renderer.setRenderAnnotsForThumbnail | ( | boolean | is_render_annots_for_thumbnail | ) | throws com.foxit.sdk.PDFException

Set rendering flag to decide whether to render annotations in thumbnail mode or not.

In thumbnail mode, the flags of annotations, "NoZoom" and "NoRotate", will be ignored. This rendering flag is available only when flag com.foxit.sdk.common.Renderer.e_RenderAnnot is used for rendering or function Renderer.renderAnnot is called. Please refer to function Renderer.setRenderContentFlags about setting flag com.foxit.sdk.common.Renderer.e_RenderAnnot .
If this function is not called, default value false will be used when this rendering flag is available.

Parameters

  [in] | is_render_annots_for_thumbnail | true means to render annotations in thumbnail mode. false means not to render annotations in thumbnail mode.

Returns
  None.

## ◆ setRenderContentFlags()

void com.foxit.sdk.common.Renderer.setRenderContentFlags | ( | int | render_content_flags | ) | throws com.foxit.sdk.PDFException

Set rendering flag to decide what content will be rendered.

If this function is not called, default value (com.foxit.sdk.common.Renderer.e_RenderPage | com.foxit.sdk.common.Renderer.e_RenderAnnot ) will be used.

Parameters

  [in] | render_content_flags | Rendering content flags. Please refer to values starting from com.foxit.sdk.common.Renderer.e_RenderPage and this should be one or a combination of these values. The com.foxit.sdk.common.Renderer.e_RenderHighlight can not be combined with com.foxit.sdk.common.Renderer.e_RenderExceptHighlight .

Returns
  None.

## ◆ setRenderEnhanceThinLines()

void com.foxit.sdk.common.Renderer.setRenderEnhanceThinLines | ( | boolean | is_render_enhance_thin_lines | ) | throws com.foxit.sdk.PDFException

Set the flag to decide whether to enhance thin lines.

If this function is not called, default value false will be used.

Parameters

  [in] | is_render_enhance_thin_lines | true means to draw zero width lines with a thicker path so they are more visible than the default single pixel. false means to draw zero width lines with a single pixel width.

Returns
  None.

## ◆ setRenderFormField()

void com.foxit.sdk.common.Renderer.setRenderFormField | ( | boolean | is_render_formfield | ) | throws com.foxit.sdk.PDFException

Set the flag to decide whether to render form fields (except signature fields).

If this function is not called, default value true will be used when this flag is available.

Parameters

  [in] | is_render_formfield | true means to render form fields (except signature fields). false means not to render form fields (except signature fields).

Returns
  None.

## ◆ setRenderImageAntiAliasing()

void com.foxit.sdk.common.Renderer.setRenderImageAntiAliasing | ( | boolean | is_render_image_antialiasing | ) | throws com.foxit.sdk.PDFException

Set the flag to decide whether to draw image anti-aliasing.

If this function is not called, default value true will be used.

Parameters

  [in] | is_render_image_antialiasing | true means to draw image anti-aliasing, and the effect would be similar to values defined in enum class InterpolationFlag. false means to draw image aliasing.

Returns
  None.

## ◆ setRenderLayer()

void com.foxit.sdk.common.Renderer.setRenderLayer | ( | boolean | is_render_one_layer | ) |

Set the flag to decide whether to render one layer or all available layers.

If this function is not called, default value true will be used when this flag is available.

Parameters

  [in] | is_render_one_layer | true means to render one layer. false means to render all available layers.

Returns
  None.

## ◆ setRenderPathAntiAliasing()

void com.foxit.sdk.common.Renderer.setRenderPathAntiAliasing | ( | boolean | is_render_path_antialiasing | ) | throws com.foxit.sdk.PDFException

Set the flag to decide whether to draw path anti-aliasing.

If this function is not called, default value true will be used.

Parameters

  [in] | is_render_path_antialiasing | true means to draw path anti-aliasing. false means to draw path aliasing.

Returns
  None.

## ◆ setRenderPathFullCovered()

void com.foxit.sdk.common.Renderer.setRenderPathFullCovered | ( | boolean | is_render_path_full_covered | ) | throws com.foxit.sdk.PDFException

A special flag that can be applied to fill mode.

If this function is not called, default value false will be used.

Parameters

  [in] | is_render_path_full_covered | true means that all pixels partially covered by the path will be fully painted, while false means not.

Returns
  None.

## ◆ setRenderPathThinLine()

void com.foxit.sdk.common.Renderer.setRenderPathThinLine | ( | boolean | is_render_path_thin_line | ) | throws com.foxit.sdk.PDFException

Set the flag to decide whether to draw path as thin line.

If this function is not called, default value false will be used.

Parameters

  [in] | is_render_path_thin_line | true means to draw path as thin line. false means not to draw path as thin line.

Returns
  None.

## ◆ setRenderSignature()

void com.foxit.sdk.common.Renderer.setRenderSignature | ( | boolean | is_render_signature | ) | throws com.foxit.sdk.PDFException

Set the flag to decide whether to render signatures or not.

If this function is not called, default value true will be used when this flag is available.

Parameters

  [in] | is_render_signature | true means to render signatures. false means not to render signatures.

Returns
  None.

## ◆ setRenderSignatureState()

void com.foxit.sdk.common.Renderer.setRenderSignatureState | ( | boolean | is_render_signature_state | ) | throws com.foxit.sdk.PDFException

Set the flag to decide whether to draw the signature state on the signature.

If this function is not called, default value true will be used.

Parameters

  [in] | is_render_signature_state | true means to draw the signature state on the signature, while false means not.

## ◆ setRenderTextAntiAliasing()

void com.foxit.sdk.common.Renderer.setRenderTextAntiAliasing | ( | boolean | is_render_text_antialiasing | ) | throws com.foxit.sdk.PDFException

Set the flag to decide whether to draw text anti-aliasing.

If this function is not called, default value true will be used.

Parameters

  [in] | is_render_text_antialiasing | true means to draw text anti-aliasing. false means to draw text aliasing.

Returns
  None.

## ◆ setScreenDPIScale()

void com.foxit.sdk.common.Renderer.setScreenDPIScale | ( | float | scale | ) |

Set the screen DPI scaling factor for rendering.

Set the screen DPI scaling scale to adapt to different DPI conditions. This value should typically match the system-reported scaling factor (e.g., 1.25f for 125% scaling in display settings) to ensure proper rendering alignment with the physical display characteristics.

Parameters

  [in] | scale | The scale of curren screen DPI(1.0f = 100% native DPI, 2.0f = 200%, etc.). Must be greater than 0 and should generally correspond to the system's recommended scaling factor. Default value: 1.0f for non-Android platforms; 2.5f for Android platform.

Note
  Currently, this screen DPI scaling factor only affects the annotations.

Returns
  None.

## ◆ startQuickRender()

Progressive com.foxit.sdk.common.Renderer.startQuickRender | ( | PDFPage | page,
|  | Matrix2D | matrix,
|  | PauseCallback | pause
| ) |  | throws com.foxit.sdk.PDFException

Start to quickly render a PDF page, mainly for thumbnail purpose.

This function is mainly used for render a page for thumbnail purpose. The rendered content will not be completed: all the annotations will be ignored, event if flag com.foxit.sdk.common.Renderer.e_RenderAnnot is set by function Renderer.setRenderContentFlags ; text content will become blurred and will be replace by pixel point.
It may still take a long time to do this quick rendering when page has complex or large contents, so Foxit PDF SDK uses a progressive process to do this.

Parameters

  [in] | page | A valid PDF page. It should have been parsed.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function pdf.PDFPage.getDisplayMatrix .
  [in] | pause | Pause callback object which decides if the rendering process needs to be paused. This can be null which means not to pause during the rendering process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.getRateOfProgress . If the rate is not 100 yet, call function Progressive.resume to continue the progress until the progress is finished.

## ◆ startRender()

Progressive com.foxit.sdk.common.Renderer.startRender | ( | PDFPage | page,
|  | Matrix2D | matrix,
|  | PauseCallback | pause
| ) |  | throws com.foxit.sdk.PDFException

Start to render a PDF page.

It may take a long time to render a PDF page with complex or large contents, so Foxit PDF SDK uses a progressive process to do this.
Widget annotation is always associated with form field and form control in Foxit PDF SDK. For how to render widget annotations, here is a recommended flow:

- After loading a PDF page, first render the page and all annotations in this page (including widget annotations).

- Then, if user uses com.foxit.sdk.pdf.interform.Filler object to fill the form, user should use function pdf.interform.Filler.render to render the focused form control instead of using function Renderer.renderAnnot .

Parameters

  [in] | page | A valid PDF page. If only to render annotations (that means only com.foxit.sdk.common.Renderer.e_RenderAnnot is set by function Renderer.setRenderContentFlags ), there is no need to parse the input page; otherwise the input page should have been parsed.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function pdf.PDFPage.getDisplayMatrix .
  [in] | pause | Pause callback object which decides if the rendering process needs to be paused. This can be null which means not to pause during the rendering process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.getRateOfProgress . If the rate is not 100 yet, call function Progressive.resume to continue the progress until the progress is finished.

## ◆ startRenderBitmap() [1/2]

Progressive com.foxit.sdk.common.Renderer.startRenderBitmap | ( | Bitmap | bitmap,
|  | Matrix2D | matrix,
|  | RectI | clip_rect,
|  | int | interpolation,
|  | PauseCallback | pause
| ) |  | throws com.foxit.sdk.PDFException

Start to render a bitmap.

It may take a long time to render a bitmap with complex or large contents, so Foxit PDF SDK uses a progressive process to do this.

Parameters

  [in] | bitmap | A valid bitmap. User should ensure the bitmap to keep valid until current rendering process is finished.
  [in] | matrix | The transformation matrix used for rendering. This matrix is used as image matrix: assume that h is image height, w is image width, and then matrix [w 0 0 h 0 0] will produce an identical image.
  [in] | clip_rect | Clip rectangle for the rendering device. This can be null. Default value: null.
  [in] | interpolation | Bitmap interpolation flags. Please refer to values starting from com.foxit.sdk.common.Bitmap.e_Downsample and this can be one or a combination of these values. If not specify any flag, please use 0. Default value: 0.
  [in] | pause | Pause callback object which decides if the rendering process needs to be paused. This can be null which means not to pause during the rendering process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.getRateOfProgress . If the rate is not 100 yet, call function Progressive.resume to continue the progress until the progress is finished.

## ◆ startRenderBitmap() [2/2]

Progressive com.foxit.sdk.common.Renderer.startRenderBitmap | ( | Bitmap | bitmap,
|  | Matrix2D | matrix,
|  | RectI | clip_rect,
|  | int | interpolation,
|  | int | alpha,
|  | PauseCallback | pause
| ) |  | throws com.foxit.sdk.PDFException

Start to render a bitmap.

It may take a long time to render a bitmap with complex or large contents, so Foxit PDF SDK uses a progressive process to do this.

Parameters

  [in] | bitmap | A valid bitmap. User should ensure the bitmap to keep valid until current rendering process is finished.
  [in] | matrix | The transformation matrix used for rendering. This matrix is used as image matrix: assume that h is image height, w is image width, and then matrix [w 0 0 h 0 0] will produce an identical image.
  [in] | clip_rect | Clip rectangle for the rendering device. This can be null.
  [in] | interpolation | Bitmap interpolation flags. Please refer to values starting from com.foxit.sdk.common.Bitmap.e_Downsample and this can be one or a combination of these values. If not specify any flag, please use 0.
  [in] | alpha | Bitmap alpha represents transparency (0 = fully transparent, 255 = fully opaque). Valid range: from 0 to 255.
  [in] | pause | Pause callback object which decides if the rendering process needs to be paused. This can be null which means not to pause during the rendering process. If this is not null, it should be a valid pause object implemented by user.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.getRateOfProgress . If the rate is not 100 yet, call function Progressive.resume to continue the progress until the progress is finished.

## ◆ startRenderReflowPage()

Progressive com.foxit.sdk.common.Renderer.startRenderReflowPage | ( | ReflowPage | reflow_page,
|  | Matrix2D | matrix,
|  | PauseCallback | pause
| ) |  | throws com.foxit.sdk.PDFException

Start to render a reflow page.

It may take a long time to render a reflow page with complex or large contents, so Foxit PDF SDK uses a progressive process to do this.

Parameters

  [in] | reflow_page | A valid reflow page. It should have been parsed.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function pdf.ReflowPage.getDisplayMatrix .
  [in] | pause | Pause callback object which decides if the rendering process needs to be paused. This can be null which means not to pause during the rendering process. If this is not null, it should be a valid pause object implemented by user. Default value:null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.getRateOfProgress . If the rate is not 100 yet, call function Progressive.resume to continue the progress until the progress is finished.

## ◆ startRenderXFAPage()

Progressive com.foxit.sdk.common.Renderer.startRenderXFAPage | ( | XFAPage | xfa_page_view,
|  | Matrix2D | matrix,
|  | boolean | is_highlight,
|  | PauseCallback | pause
| ) |  | throws com.foxit.sdk.PDFException

Start to render an XFA page.

It will take a long time to render an XFA page with complex or large contents, so Foxit PDF SDK uses a progressive process to do this.

Parameters

  [in] | xfa_page_view | A valid XFA page.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function addon.xfa.XFAPage.getDisplayMatrix .
  [in] | is_highlight | true means to highlight XFA widgets, and false means not to highlight XFA widgets.
  [in] | pause | Pause callback object which decides if the rendering process needs to be paused. This can be null which means not to pause during the rendering process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.getRateOfProgress . If the rate is not 100 yet, call function Progressive.resume to continue the progress until the progress is finished.